<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <title>Constructors</title>
</head>

<body>
  <div class="wrap">
    <button id="btnRotatePlanet">Rotate Planet</button>
  </div>
  <script>
    /*
  
      Задание:
  
      Написать функцию конструктор, которая будет иметь приватные и публичные свойства.
      Публичные методы должны вызывать приватные.
  
      Рассмотрим на примере планеты:
  
        - На вход принимаются параметр Имя планеты.
  
        Создается новый обьект, который имеет публичные методы и свойства:
        - name (передается через конструктор)
        - population ( randomPopulation());
        - rotatePlanet(){
          let randomNumber = Math.floor(Math.random() * (1000 - 1 + 1)) + 1;
          if ( (randomNumber % 2) == 0) {
            growPopulation();
          } else {
            Cataclysm();
          }
        }
  
        Приватное свойство:
        populationMultiplyRate - случайное число от 1 до 10; // Коэффициент прироста населения
  
        Приватные методы
        randomPopulation -> Возвращает случайное целое число от 1.000 до 10.000
        growPopulation() {
          функция которая берет приватное свойство populationMultiplyRate
          которое равняется случайному числу от 1 до 10 и умножает его на 100.
          Дальше, число которое вышло добавляет к популяции и выводит в консоль сообщение,
          что за один цикл прибавилось столько населения на планете .
        }
        Cataclysm(){
          Рандомим число от 1 до 10 и умножаем его на 250;
          То число которое получили, отнимаем от популяции.
          В консоль выводим сообщение - от катаклизма погибло Х человек на планете.
        }
  
    */
    document.addEventListener('DOMContentLoaded', function () {
      const btnRotatePlanet = document.getElementById('btnRotatePlanet');
      btnRotatePlanet.addEventListener('click', rotatePlanetClick)

      const MULTIPLY_RATE_MIN = 1;
      const MULTIPLY_RATE_MAX = 10
      const POPULATION_MIN = 1000;
      const POPULATION_MAX = 10000;

      function Planet(name) {
        // private
        let populationMultiplyRate;

        this.name = name;

        // this.population = function () {
        //   console.log("population");
        //   return randomPopulation;
        // };

        this.population = randomPopulation(POPULATION_MIN, POPULATION_MAX);

        this.rotatePlanet = function () {
         let randomNumber = Math.floor(Math.random() * (1000 - 1 + 1)) + 1;
          if ((randomNumber % 2) == 0) {
            growPopulation();
          } else {
            cataclysm();
          }
          console.log(this.population);
        }

        // private
        let growPopulation = () => {
           populationMultiplyRate = getRandom(MULTIPLY_RATE_MIN, MULTIPLY_RATE_MAX);
           this.population += populationMultiplyRate * 100;
          console.log(`за один цикл прибавилось ${populationMultiplyRate * 100} населения на планете` );
        }

        // private
        let cataclysm = () => {
          populationMultiplyRate = getRandom(MULTIPLY_RATE_MIN, MULTIPLY_RATE_MAX);
          this.population -= populationMultiplyRate * 250;
          console.log(`от катаклизма погибло ${populationMultiplyRate * 250} человек на планете `);
         }

        // private
        function randomPopulation() {
          return getRandom(POPULATION_MIN, POPULATION_MAX);
        }

        function getRandom(minValue, maxValue) {
          let min = Math.ceil(minValue);
          let max = Math.floor(maxValue);
          return Math.floor(Math.random() * (max - min + 1)) + min;
        }
      }

      let earth = new Planet("earth");
      console.log(`Население планеты ${earth.name} составляет ${earth.population}`);

      function rotatePlanetClick(){
        earth.rotatePlanet();
      }
    })
  </script>
</body>

</html>